
#ifndef __skymap_functions_h__
#define __skymap_functions_h__

// C, C++, and STL includes.
#include <iostream>

// HEALPix C++ module includes.
#include <healpix-cxx/cxxsupport/constants.h>
#include <healpix-cxx/healpix/healpix_map.h>

// Forward declarations.
class vec3;
class pointing;

// Functions.
double angdist(const vec3 &v1, const vec3 &v2);
double angdist(const pointing &p1, const pointing &p2);
double angdist(double th1, double ph1, double th2, double ph2);

template <class T> void
normalize_skymap(Healpix_Map<T> &map);

template <class T> void
rescale_skymap(Healpix_Map<T> &map, const T &scale);

template <class T> void
rescale_skymap_to_one(Healpix_Map<T> &map);

template <class T> Healpix_Map<T>
product_of_skymaps(const Healpix_Map<T> &m1, const Healpix_Map<T> &m2);

template <class T> Healpix_Map<T>
sum_of_skymaps(const Healpix_Map<T> &m1, const Healpix_Map<T> &m2);

#include "skymap_functions.inl"

#endif // __skymap_functions_h__

